from structures import Record, Cluster
from VerPart import VerPart
from HorPart import HorPart
from DatasetReconstruct import DatasetReconstruct
from evaluation import Evaluation
import time,sys

def main():
    maxClusterSize = 11  #note that cluster size would be (maxClusterSize - 1)
                        #due to coding reason
    #Adjust k and m value here
    k = 5
    m = 2
    records = []
    print("Select dataset: \n1 - POS1 \n2 - WV1 \n3 - WV2 \n4 - data111")
    option = input("Enter number: ")
    if (option == '1'):
        inFile = open("POS1.txt", "r")
        data = inFile.read().split(",\n")
        recNum = 0                                 
        for r in data:
            rec = Record(recNum+1)
            records.append(rec)
            x = r.split(",")
            records[recNum].setRecValue(set(x))
            recNum+=1
        #for i in records:
            #print(i)

    elif (option == '2'):
        inFile = open("WV1.txt", "r")
        data = inFile.read().split(" -1 -2\n")
        recNum = 0
        for r in data:
            rec = Record(recNum+1)
            records.append(rec)
            x = r.split(" -1 ")
            records[recNum].setRecValue(set(x))
            recNum+=1
        #for i in records:
            #print(i)

    elif (option == '3'):
        inFile = open("WV2.txt", "r")
        data = inFile.read().split(" -1 -2\n")
        recNum = 0
        for r in data:
            rec = Record(recNum+1)
            records.append(rec)
            x = r.split(" -1 ")
            records[recNum].setRecValue(set(x))
            recNum+=1
        #for i in records:
            #print(i)
            
    elif (option == '4'):
        inFile = open("data111.txt", "r")
        data = inFile.read().splitlines()
        recNum = 0
        for r in data:
            rec = Record(recNum+1)
            records.append(rec)
            x = r.split(",")
            records[recNum].setRecValue(set(x))
            recNum+=1
        #for i in records:
            #print(i)
    else:
        print("Please enter a valid number.")
        sys.exit()
    #Horizontal Partitioning
    start2 = time.time()
    horpart = HorPart(maxClusterSize,k)
    clusters = horpart.horizonPartitioning(records)
    end2 = time.time()
    print("Horizontal Partitioning:",end2-start2)

    #Vertical Partitioning
    start3 = time.time()
    verpart = VerPart(k,m)
    for i in clusters:
        rc = verpart.vertPartitioning(i)

    #for i in clusters:
        #print(i)
    end3 = time.time()
    print("Vertical Partitioning Time:",end3-start3)
    print("Total time spent on disassociation:", end3- start2)

    #Dataset Reconstruction
    start4 = time.time()
    reconIni = DatasetReconstruct()
    recon = reconIni.reconstructDataset(clusters)
    end4 = time.time()
    print("Dataset Reconstruction Time:",end4-start4)
    #for record in recon:
        #print(record)

    #Relative Error
    evaluation = Evaluation()
    relativeErr = evaluation.averageRelativeError(records,recon)
    print("Average Relative Error:",relativeErr)

    #Top-K Deviation
    topKD = evaluation.topKdeviation(1000,records,recon)
    print("Top-K Deviation:",topKD)

main()
    
    
