#Object class representing a record


class Record:
    def __init__(self, recID):
        self.recID = "R"+str(recID)
        self.recVal = set()

    def addRecValue(self, new_recVal):
        self.recVal.add(new_recVal)

    def extRecValue(self, new_recVal):
        self.recVal.union(new_recVal)

    def getRecID(self):
        return self.recID
        
    def getRecValue(self):
        return self.recVal

    def setRecValue(self,new_recVal):
        self.recVal = new_recVal

    def __str__(self):
        return '{} : {} \n'.format(self.getRecID(), self.getRecValue())

    def __repr__(self):
        return '{} \n'.format(self.getRecValue() or {})


#Object class representing a cluster
class Cluster:
    def __init__(self, clusterID, records: [Record]):
        self.clusterID = "P"+clusterID
        self.records = records
        self.recordChunks = [RecordChunk]
        self.termChunk = {}
        
    def getClusterID(self):
        return self.clusterID

    def setClusterID(self,new_clusterID):
        self.clusterID = new_clusterID

    def getRecords(self):
        return self.records

    def addRecord(self, new_record):
        self.records.append(new_record)

    def setTermChunk(self, new_termChunk):
        self.termChunk = new_termChunk

    def getTermChunk(self):
        return self.termChunk

    def setRecordChunk(self, new_recordChunk):
        self.recordChunks = new_recordChunk

    def getRecordChunk(self):
        return self.recordChunks

    def __str__(self):
        string = []
        string.append('Cluster: \n')
        string.append('{} : {} \n'.format(str(self.getClusterID()), repr(self.getRecords())))
        string.append('Record Chunk: \n')
        for record in self.getRecordChunk():
            string.append('{} : {} \n'.format(str(record.getRecordChunkID()), repr(record.getRecordChunk())))
        string.append('Term Chunk: \n')
        string.append(str(list(self.getTermChunk())))
        string.append('\n')
        return ''.join(string)
    
#Object class representing a record chunk
class RecordChunk:
    def __init__(self, recordChunkID, recordChunk: [Record]):
        self.recordChunkID = "C"+str(recordChunkID)
        self.recordChunkValue = recordChunk

    def getRecordChunkID(self):
        return self.recordChunkID

    def setRecordChunkID(self, newChunkID):
        self.recordChunkID = newChunkID

    def setRecordChunk(self, new_recordChunk):
        self.recordChunkValue = new_recordChunk

    def addRecord(self, new_record):
        self.recordChunkValue.append(new_record)

    def getRecordChunk(self):
        return self.recordChunkValue

    def __str__(self):
        return '{} : {} \n'.format(self.getRecordChunkID(), repr(self.getRecordChunk()))

    def __repr__(self):
        return '{} \n'.format(self.getRecordChunk())





